using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Contabilidad.General;
using System.Data.SqlClient;

namespace Exferia_Contabilidad._1_Datos
{
    public class CTA_PredefinidosImportes_Datos : ABS_Datos
    {

        #region Listado
        private List<INTERNO_CTA_PredefinidosImportes_Listado_Modelo> g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosImportes).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo != null) && (g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo.Count() > 0))
                {
                    lst_CTA = g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_CTA;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosImportes).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo != null) && (g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo.Count() > 0))
                {
                    dnm_CTA = g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                  " SELECT " +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.id) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.id) + "," +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.codigo) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.codigo) + "," +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.descripcion) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.descripcion) + "," +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.vector) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.vector) + "," +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.vector_AUX_1) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.vector_AUX_1) + "," +
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.procesoCalculo) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.procesoCalculo) + "," +
                      //Ids
                      nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.idPredefinidoFichero) + " = " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.idPredefinidoFichero) + "," +
                      //PredefinidoFichero
                      (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros)))
                          ?
                              (
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_Codigo) + " = " + nameof(CTA_PredefinidosFicheros) + "." + nameof(CTA_PredefinidosFicheros.codigo) + "," +
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_Descripcion) + " = " + nameof(CTA_PredefinidosFicheros) + "." + nameof(CTA_PredefinidosFicheros.descripcion) + "," +
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_FechaBorrado) + " = " + nameof(CTA_PredefinidosFicheros) + "." + nameof(CTA_PredefinidosFicheros.fechaBorrado)
                              )
                          :
                              (
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_Codigo) + " = ''," +
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_Descripcion) + "= '', " +
                                  nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros_FechaBorrado) + " = NULL "
                              )
                      ) +
                   " FROM " + nameof(CTA_PredefinidosImportes) +
                   // PredefinidoFichero
                   (
                       (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.PredefinidosFicheros)))
                       ?
                           (
                               " LEFT JOIN " + nameof(CTA_PredefinidosFicheros) + " ON " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.idPredefinidoFichero) + "=" + nameof(CTA_PredefinidosFicheros) + "." + nameof(CTA_PredefinidosFicheros.id)
                           )
                       : ("")
                   ) +
                    " WHERE " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.fechaBorrado) + " IS null AND " +
                           (_lng_id > -1 ? nameof(CTA_PredefinidosImportes) + "." + (nameof(CTA_PredefinidosImportes.id) + "=@id") : "1 = 1") + " AND " +
                           //Filtro por datos del padre relacionado
                           (
                               !str_Padre_Opcion.Equals("")
                                   //PredefinidoFichero
                                   ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_CTA_PREDEFINIDOFICHERO)
                                       ? (nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.idPredefinidoFichero) + "=@id_Padre")
                                       : ("1 = 1")
                                   : ("1 = 1")
                           );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@id_Padre",  lng_Padre_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_CTA_PredefinidosImportes_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_PredefinidosImportes_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_CTA_PredefinidosImportes_Listado_Modelo g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosImportes).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo != null)
                {
                    dnm_CTA = g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosImportes).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo != null)
                {
                    dnm_CTA = g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.id) + " = " + nameof(CTA_PredefinidosImportes.id) + "," +
                       nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.codigo) + " = " + nameof(CTA_PredefinidosImportes.codigo) + "," +
                       nameof(INTERNO_CTA_PredefinidosImportes_Listado_Modelo.descripcion) + " = " + nameof(CTA_PredefinidosImportes.descripcion) +
               " FROM " + nameof(CTA_PredefinidosImportes) +
               " WHERE " + nameof(CTA_PredefinidosImportes.fechaBorrado) + " IS null AND " +
                       (
                         _lng_id > -1
                               ? (nameof(CTA_PredefinidosImportes.id) + "=" + _lng_id)
                               : (
                                   //Filtrar por Codigo
                                   (_str_CampoBusqueda.Equals(nameof(CTA_PredefinidosImportes.codigo)))
                                       ? (nameof(CTA_PredefinidosImportes.codigo) + "=@Filtro")
                                       //Filtrar por Descripcion
                                       : (nameof(CTA_PredefinidosImportes.descripcion) + "=@Filtro")
                                 )
                       )
                       +
                        //Filtro por datos del padre relacionado
                        (
                            !str_Padre_Opcion.Equals("")
                                //PredefinidoFichero
                                ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_CTA_PREDEFINIDOFICHERO)
                                    ? (" AND " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.idPredefinidoFichero) + "=@id_Padre")
                                    : (" and 1 = 1")
                                : (" and 1 = 1")
                        );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro),
                     new SqlParameter("@id_Padre",  lng_Padre_id)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_CTA_PredefinidosImportes_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_PredefinidosImportes_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTA_PredefinidosImportes g_mdl_CTA_PredefinidosImportes = null;
        public CTA_PredefinidosImportes Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTA_PredefinidosImportes;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_CTA_PredefinidosImportes = obj_Exferia_Entities.Database.SqlQuery<CTA_PredefinidosImportes>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #region Modelo Listado
        private List<CTA_PredefinidosImportes> g_lst_CTA_PredefinidosImportes = null;

        public List<CTA_PredefinidosImportes> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " + nameof(CTA_PredefinidosImportes) + "." + nameof(CTA_PredefinidosImportes.id) + " in (" + str_Filtro_IDS + ")";

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_CTA_PredefinidosImportes;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CTA_PredefinidosImportes = obj_Exferia_Entities.Database.SqlQuery<CTA_PredefinidosImportes>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_PredefinidosImportes_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                     nameof(CTA_PredefinidosImportes.id) + " , " +
                     nameof(CTA_PredefinidosImportes.codigo) + " , " +
                     nameof(CTA_PredefinidosImportes.descripcion) + " , " +
                     nameof(CTA_PredefinidosImportes.vector) + " , " +
                     nameof(CTA_PredefinidosImportes.vector_AUX_1) + " , " +
                     nameof(CTA_PredefinidosImportes.procesoCalculo) + " , " +
                     nameof(CTA_PredefinidosImportes.idPredefinidoFichero) + " , " +
                     nameof(CTA_PredefinidosImportes.fechaBorrado) +
                " FROM " + nameof(CTA_PredefinidosImportes);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
